<?php
namespace Avaliacao\Entities;

use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class AvlServicoaval extends Base\AvlServicoaval
{
    public static function retornaServicoAvaliacao($nrorg, $nravaliacao, $cdfilial, $cdservico){
        $obj = self::getObjectByWhere(
            'NRORG = ? AND NRAVALIACAO = ? AND CDFILIAL = ? AND CDSERVFILI = ?',
            array(
                $nrorg,
                $nravaliacao,
                $cdfilial,
                $cdservico
            )
        );
        return $obj;
    }

    public function insereServicoAvaliacao(
        $nrorg,
        $nravaliacao,
        $cdfilial,
        $cdservfili
    ) {
        try {
            $obj = new self();

            $obj->setNrservicoaval(NovoCodigo::geraCodigo($nrorg, 'AVL_SERVICOAVAL',1,10,true));
            $obj->setNravaliacao($nravaliacao);
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setCdfilial($cdfilial);
            $obj->setCdservfili($cdservfili);
            $obj->setIdativo('S');
            $obj->setNrorg($nrorg);
            $obj->setNrorginclusao($nrorg);
            $obj->persist();

            Registry::getEntityManager()->flush();

            return true;

        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }

    }

    public static function retornaServicosPorAvaliacao($nrorg, $nravaliacao) {
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND NRAVALIACAO = ?',
            array(
                $nrorg,
                $nravaliacao,
            )
        );

        return $objs;
    }

    public static function excluiServicosAvaliacao($nrorg, $nravaliacao){
        try {
            $sql = "DELETE FROM AVL_SERVICOAVAL
                    WHERE NRORG = {$nrorg}
                      AND NRAVALIACAO = {$nravaliacao}";
            \Setforms2\Shared\Connection::getInstance()->execute($sql);
            return true;
        } catch(\Exception $e) {
            return false;
        }

    }
}